summaryrefslogtreecommitdiffstats
path: root/target/linux/bcm53xx/base-files
diff options
context:
space:
mode:
authorRafał Miłecki <zajec5@gmail.com>2015-04-12 11:46:16 +0000
committerRafał Miłecki <zajec5@gmail.com>2015-04-12 11:46:16 +0000
commit24d40980b0822dff89d8ae75eedd85fa98df2cc1 (patch)
tree6b0c05a0a5f495468fb44b3a66233f635f1aa7e0 /target/linux/bcm53xx/base-files
parentab6462dd56829f5c8344bc2f97ca448e2875e64d (diff)
downloadmaster-31e0f0ae-24d40980b0822dff89d8ae75eedd85fa98df2cc1.tar.gz
master-31e0f0ae-24d40980b0822dff89d8ae75eedd85fa98df2cc1.tar.bz2
master-31e0f0ae-24d40980b0822dff89d8ae75eedd85fa98df2cc1.zip
bcm53xx: add platform_pre_upgrade to prepare for kernel+UBI sysupgrade
We can now detect that provided firmware contains kernel and UBI image partitions. Flashing it in a sane way (keeping erase counters) still needs to be implemented. Signed-off-by: Rafał Miłecki <zajec5@gmail.com> SVN-Revision: 45391
Diffstat (limited to 'target/linux/bcm53xx/base-files')
-rw-r--r--target/linux/bcm53xx/base-files/lib/upgrade/platform.sh28
1 files changed, 28 insertions, 0 deletions
diff --git a/target/linux/bcm53xx/base-files/lib/upgrade/platform.sh b/target/linux/bcm53xx/base-files/lib/upgrade/platform.sh
index c3f9a14c78..26a32e30a4 100644
--- a/target/linux/bcm53xx/base-files/lib/upgrade/platform.sh
+++ b/target/linux/bcm53xx/base-files/lib/upgrade/platform.sh
@@ -124,6 +124,34 @@ platform_extract_trx_from_cybertan() {
dd if="$1" of="$2" bs=32 skip=1
}
+platform_pre_upgrade() {
+ local file_type=$(platform_identify "$1")
+ local dir="/tmp/sysupgrade-bcm53xx"
+ local trx="$1"
+
+ [ "$(platform_flash_type)" != "nand" ] && return
+
+ # Extract trx
+ case "$file_type" in
+ "chk") trx="/tmp/$1.trx"; platform_extract_trx_from_chk "$1" "$trx";;
+ "cybertan") trx="/tmp/$1.trx"; platform_extract_trx_from_cybertan "$1" "$trx";;
+ esac
+
+ # Extract partitions from trx
+ rm -fR $dir
+ mkdir -p $dir
+ otrx -e "$trx" \
+ -1 $dir/kernel \
+ -2 $dir/root
+
+ # Firmwares without UBI image should be flashed "normally"
+ local root_type=$(identify $dir/root)
+ [ "$root_type" != "ubi" ] && return
+
+ echo "Provided firmware contains kernel and UBI image, but flashing it in unsupported yet"
+ exit 1
+}
+
platform_do_upgrade() {
local file_type=$(platform_identify "$1")
local trx="$1"